int getDataValue(int myvalue, int maxValue, int minValue, int incten, int runover) {
  if (button1State == 0 && button4State == 1 && button4StatePrev == 0) {
    button4StatePrev = 1;
    myvalue--;
  }
  if (button4State == 0 && button4StatePrev == 1) {
    button4StatePrev = 0;
  }

  if (button1State == 0 && button5State == 1 && button5StatePrev == 0) { // SCROLL THRU MENU UP
    button5StatePrev = 1;
    myvalue++;
  }
  if (button5State == 0 && button5StatePrev == 1) {
    button5StatePrev = 0;
  }

  if (button2State == 1) myvalue = invalue[1];
  
  if (runover == 0 && myvalue > maxValue) myvalue = maxValue;
  if (runover == 0 && myvalue < minValue) myvalue = minValue;
  if (runover == 1 && myvalue > maxValue) myvalue = minValue;
  if (runover == 1 && myvalue < minValue) myvalue = maxValue;
  return myvalue;
}

void printstep (byte step, char type) {
  if (setupmode == 0) {
    if (step == 0) {
      lcd.setCursor(1, 1);
      lcd.print(F("               "));
    }
    lcd.setCursor(step, 1);
    lcd.print(type);
  }
}


void showtranspose(int transpose) {
  lcd.setCursor(4, 0);
  if (setupmode == 0) {
    if (transpose < 0) {
      lcd.print(F(" Trns"));
      lcd.setCursor(9, 0);
      lcd.print(transpose);
      if (transpose > -10) {
        lcd.setCursor(11, 0);
        lcd.print(F(" "));
      }
    }
    if (transpose == 0) lcd.print(F("        "));
    if (transpose > 0) {
      lcd.print(F(" Trns+"));
      lcd.setCursor(10, 0);
      lcd.print(transpose);
      if (transpose < 10) {
        lcd.setCursor(11, 0);
        lcd.print(F(" "));
      }
    }
  }
}



void clearscreen() {
  lcd.setCursor(0, 0);
  lcd.print(F("                "));
  lcd.setCursor(0, 1);
  lcd.print(F("                "));
}




void timerIsr()
{
  if (clockmode == 0) {
    if (dinclockcounter == 0) {
      if (sendclock == 2 || sendclock == 3) digitalWrite(dinClockPin, HIGH);
      if (sendclock == 1 || sendclock == 2) {
        using namespace midi;
        MIDI.sendRealTime(Clock);
      }
    }
    if (intclockcounter == 6) {
      digitalWrite(clockOutPin, HIGH);
    }

    if (intclockcounter == (8 * clockfactor)) {
      if (clockmode == 0) digitalWrite(clockOutPin, LOW);
    }
    if (dinclockcounter == 4) {
      if (sendclock == 2 || sendclock == 3) digitalWrite(dinClockPin, LOW);
    }

    // We send the start command inbetween two clock commands and not if the DIN-clock still is high
    if (dinclockcounter == 5) {
      if (startFlag == 1) {
        runmode = 1;
        if (sendclock == 1 || sendclock == 2) {
          using namespace midi;
          MIDI.sendRealTime(Start);
        }
        if (sendclock == 2 || sendclock == 3) {
          digitalWrite(dinGatePin, HIGH);
        }
        startFlag = 0;
      }
    }

    intclockcounter ++;
    dinclockcounter ++;

    if (intclockcounter == (16 * clockfactor)) {
      intclockcounter = 0;
    }
    if (dinclockcounter == 8) {
      dinclockcounter = 0;
    }
  }

}




void setClockFactor() {
  if (inclockdivider == 0) { // 1/16
    clockfactor = 3;
  }
  if (inclockdivider == 1) {// 1/8
    clockfactor = 6;
  }
  if (inclockdivider == 2) {// 1/4
    clockfactor = 12;
  }
  if (inclockdivider == 3) {// 1/1
    clockfactor = 48;
  }
  if (inclockdivider == 4) {// 2/1
    clockfactor = 96;
  }
  if (inclockdivider == 5) {// 1/12
    clockfactor = 4;
  }
  if (inclockdivider == 6) {// 1/24
    clockfactor = 2;
  }
  if (intclockcounter >= (16 * clockfactor)) {
    intclockcounter = 0;
    dinclockcounter = 0;
  }
  if (midiclockcounter >= (2 * clockfactor)) {
    midiclockcounter = 0;
  }
}





void savesequence() {
  lcd.setCursor(1, 1);
  lcd.print(F("               "));
  byte track;
  for (track = 0; track < maxTracks; track++) {
    for ( stepnumber[track] = 0; stepnumber[track] < maxSteps; stepnumber[track]++) {
      uint16_t address = 32 + (9 * maxTracks) + (track * maxSteps) + stepnumber[track];
      EEPROM.update(address, stepvalue[stepnumber[track]][track]);
    }
  }

  for (track = 0; track <= maxTracks - 1; track++) {
    uint16_t address = 32 + (7 * maxTracks) + track;
    EEPROM.update(address, laststep[track]);
  }

  lcd.setCursor(1, 1);
  lcd.print(F("SAVE DONE     "));
}

void loadsequence() {
  byte track;
  for (track = 0; track < maxTracks; track++) {
    for ( stepnumber[track] = 0; stepnumber[track] < maxSteps; stepnumber[track]++) {
      uint16_t address = 32 + (9 * maxTracks) + (track * maxSteps) + stepnumber[track];
      stepvalue[stepnumber[track]][track] = EEPROM.read(address);
    }
  }
  for (track = 0; track < maxTracks; track++) {
    uint16_t address = 32 + (7 * maxTracks) + track;
    laststep[track] = EEPROM.read(address);
  }

  lcd.setCursor(1, 1);
  lcd.print(F("LOAD DONE      "));
  //delay(1000);
  clearscreen();
}

void midireset() {
  byte track;
  byte i = 0;
  for (track = 0; track < maxTracks; track++) {
    for (i = 0; i <= 126 ; i++) {
      MIDI.sendNoteOff(i, 0, outchannel[track]);
      //  delay(1);
    }
    MIDI.sendControlChange(123, 0, outchannel[track]);
  }
}

void adjustpotis() {
  invalueRaw[0] = analogRead(input[0]);
  invalueRaw[1] = analogRead(input[1]);
  invalueRaw[2] = analogRead(input[2]);
  i = 0;
  while (i < 3) {
    invalueOffset[i] = 0;
    while ((invalueRaw[i] + invalueOffset[i]) != 1023) {
      invalueRaw[i] = analogRead(input[i]) + 0.5 ;
      if ((invalueRaw[i] + invalueOffset[i]) < 1023) invalueOffset[i]++;
      if ((invalueRaw[i] + invalueOffset[i]) > 1023) invalueOffset[i]--;
      lcd.setCursor(0, 0);
      lcd.print(invalueOffset[i]);
      lcd.print(" ");
      lcd.setCursor(7, 0);
      if (i == 0) lcd.print(F("Tempo"));
      if (i == 1) lcd.print(F("CV1  "));
      if (i == 2) lcd.print(F("CV2  "));
    }
    if ((invalueRaw[i] + invalueOffset[i]) == 1023 ) {
      lcd.setCursor(0, 1);
      lcd.print(F("Good!  "));
      EEPROM.update(i, invalueOffset[i]);
      delay(500);
      clearscreen();
      i++;
    }
  }
  clearscreen();
  i = 0;
}

void triggerreset() {
  for (i = 0; i <= maxTracks - 1; i++) {
    ontrigger[i] = 0;
    offtrigger[i] = 0;
  }
}

void loadsettings() {
  /* READ GENERIC PARATMETERS FROM EEPROM */
  outchannelall   = EEPROM.read(4);
  inchannel       = EEPROM.read(5);
  //clockmode       = EEPROM.read(6);
  clockmode       = 0; // we always set the clock to internal clock on resets
  transposecenter = EEPROM.read(7);
  transposemode   = EEPROM.read(8);
  notelength      = EEPROM.read(10);
  notethrumode    = EEPROM.read(11);
  controlthrumode = EEPROM.read(12);
  programthrumode = EEPROM.read(13);
  bendthrumode    = EEPROM.read(14);
  otherthrumode   = EEPROM.read(15);
  velocitymode    = EEPROM.read(16);
  inclockdivider  = EEPROM.read(17);
  startstopmode   = EEPROM.read(18);
  sendclock       = EEPROM.read(19);
  osmoseenable    = EEPROM.read(20);

  /* READ TRACK PARATMETERS FROM EEPROM */
  for (i = 0; i <= maxTracks - 1; i++) {
    //laststep[i]     = EEPROM.read(16 + i);
    tracktype[i]      = EEPROM.read(32 + (0 * maxTracks) + i);
    ccnumber[i]       = EEPROM.read(32 + (1 * maxTracks) + i);
    clockdivider[i]   = EEPROM.read(32 + (2 * maxTracks) + i);
    outchannel[i]     = EEPROM.read(32 + (3 * maxTracks) + i);
    velocitysource[i]  = EEPROM.read(32 + (4 * maxTracks) + i);
    transposesource[i] = EEPROM.read(32 + (5 * maxTracks) + i);
    playonstart[i]    = EEPROM.read(32 + (6 * maxTracks) + i);
    /*The following sets basic settings*/
    velocity[i] = 96;
    transpose[i] = 0;
  }
}

void eepromfactoryreset() {
  clearscreen();
  lcd.setCursor(0, 0);
  lcd.print(F("Reset EEprom"));
  /* WRITE GENERIC PARATMETERS TO EEPROM */
  EEPROM.update(4, 1); //outchannelall
  EEPROM.update(5, 1); //inchannel
  EEPROM.update(6, 0); //clockmode
  EEPROM.update(7, 60); //transposecenter
  EEPROM.update(8, 3); //transposemode
  EEPROM.update(9, 1); // noteoffmode
  EEPROM.update(10, 30); //notelength
  EEPROM.update(11, 3); //notethrumode
  EEPROM.update(12, 1); //controlthrumode
  EEPROM.update(13, 0); //programthrumode
  EEPROM.update(14, 1); //bendthrumode
  EEPROM.update(15, 0); //otherthrumode
  EEPROM.update(16, 0); //velocitymode

  /* WRITE TRACK PARATMETERS TO EEPROM */
  for (i = 0; i < maxTracks; i++) {
    EEPROM.update(32 + (0 * maxTracks) + i, 0); //tracktype[i]
    EEPROM.update(32 + (1 * maxTracks) + i, 7); //ccnumber[i]
    EEPROM.update(32 + (2 * maxTracks) + i, i + 1); //clockdivider[i]
    EEPROM.update(32 + (3 * maxTracks) + i, i + 1); //outchannel[i]
    EEPROM.update(32 + (4 * maxTracks) + i, maxTracks); //velocitysource[i]
    EEPROM.update(32 + (5 * maxTracks) + i, maxTracks + 1); //transposesource[i]
    EEPROM.update(32 + (6 * maxTracks) + i, 1); //playonstart[i]
    /*The following sets basic settings*/
    velocity[i] = 96;
    transpose[i] = 0;
  }
}

void loadfactorysequence() {
  lcd.setCursor(0, 0);
  lcd.print(F("RESET PATTERN"));
  lcd.setCursor(1, 1);
  lcd.print(F("               "));
  byte track;
  for (track = 0; track < maxTracks; track++) {
    for (i = 0; i < maxSteps; i++) {
      stepvalue[i][track] = 128;
    }
  }
  stepvalue[0][0] = 48;
  stepvalue[0][1] = 52;
  stepvalue[0][2] = 52;
  stepvalue[0][3] = 59;
  stepvalue[0][4] = 48 + 12;
  stepvalue[0][5] = 52 + 12;
  stepvalue[0][6] = 55 + 12;
  stepvalue[0][7] = 59 + 12;
  stepvalue[0][8] = 48 + 24;
  stepvalue[0][9] = 52 + 24;
  stepvalue[0][10] = 55 + 24;
  stepvalue[0][11] = 59 + 24;
  stepvalue[0][12] = 48 + 36;
  stepvalue[0][13] = 52 + 36;
  stepvalue[0][14] = 55 + 36;
  stepvalue[0][15] = 59 + 36;
  for (track = 0; track < maxTracks; track++) {
    laststep[track] = 2;
  }
}


void deletesequence() {
  lcd.setCursor(0, 0);
  lcd.print(F("DELETE PATTERN"));
  lcd.setCursor(1, 1);
  lcd.print(F("               "));
  delay(800);
  for (i = 0; i <= maxTracks - 1; i++) {
    for ( stepnumber[i] = 0; stepnumber[i] <= maxSteps - 1; stepnumber[i]++) {
      stepvalue[stepnumber[i]][i] = 128;
    }
  }
  for (i = 0; i <= maxTracks - 1; i++) {
    laststep[i] = 1;
  }
}
